var PushPop = {
  post: function(e, uri) {
    var f = document.createElement('form');
    f.style.display = 'none';
    e.parentNode.appendChild(f);
    f.method = 'POST';
    f.action = uri ? uri : e.href;
    f.submit();
  },

  initSlider: function(uri, bias) {
    new Control.Slider('handle', 'track', { 
      axis: 'vertical',
      sliderValue: PushPop.biasToFloat(bias || 0),
      onChange: function(v) { PushPop.updateBias(uri, PushPop.floatToBias(v)); }
    });
  },

  biasToFloat: function(b) {
    return (b + 100.0) / 200.0;
  },

  floatToBias: function(f) {
    return Math.round(f * 200 - 100);
  },

  showBias: function() { $('bias').show(); },
  hideBias: function() { $('bias').hide(); },

  showBiasSpinner: function() { $('biasSpinner').show(); },
  hideBiasSpinner: function() { $('biasSpinner').hide(); },

  updateBias: function(uri, value) {
    PushPop.hideBias();
  	PushPop.showBiasSpinner();
  	new Ajax.Updater(
  		'bias',
  		uri, 
  		{ asynchronous:true, parameters:{ bias:value }, 
  		  onComplete:function(request) { PushPop.hideBiasSpinner(); PushPop.showBias(); } }
  	);
  }
}